// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers', 'starter.services', 'ngCordova', 'ngMap'])

.run(function($ionicPlatform ) {
	$ionicPlatform.ready(function() {
	// Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
	// for form inputs)
		if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
			cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
			cordova.plugins.Keyboard.disableScroll(true);
		}

		if (window.StatusBar) {
			// org.apache.cordova.statusbar required
			StatusBar.style(1);
		}
		// $cordovaPlugin.someFunction().then(success, error);

	});
})

.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

	$ionicConfigProvider.views.maxCache(5);
	$ionicConfigProvider.backButton.previousTitleText('');
	
	$ionicConfigProvider.platform.android.tabs.position('bottom');

	$stateProvider
	.state('app', {
		url: '/app',
		abstract: true,
		templateUrl: 'templates/tabs.html',
		controller: 'MainCtrl as mainCtrl'
	})

	.state('app.home', {
		url: '/home',
		views: {
			'mainContent': {
				templateUrl: 'templates/home.html',
				controller: 'HomeCtrl'
			}
		}
	})
	.state('app.property', {
		url: '/property/:propertyId',
		views: {
			'mainContent': {
				templateUrl: 'templates/details/property.html',
				controller: 'PropertyDetailCtrl'
			}
		}
	})
	.state('app.propertyMap', {
		url: '/property-map/:propertyId',
		views: {
			'mainContent': {
				templateUrl: 'templates/details/property-map.html',
				controller: 'PropertyMapDetailCtrl'
			}
		}
	})
	.state('app.agents', {
		url: '/agents',
		views: {
			'mainContent': {
				templateUrl: 'templates/agents.html',
				controller: 'AgentsCtrl'
			}
		}
	})
	.state('app.agent', {
		url: '/agent/:agentId',
		views: {
			'mainContent': {
				templateUrl: 'templates/details/agent.html',
				controller: 'AgentDetailCtrl'
			}
		}
	})
	.state('app.search', {
		url: '/search',
		views: {
			'mainContent': {
				templateUrl: 'templates/search.html',
				controller: 'SearchCtrl'
			}
		}
	})
	.state('app.searchCurrentLocation', {
		url: '/current-location',
		views: {
			'mainContent': {
				templateUrl: 'templates/search-current-location.html',
				controller: 'SearchCurrentLocationCtrl'
			}
		}
	})
	.state('app.searchResult', {
		url: '/search-result',
		views: {
			'mainContent': {
				templateUrl: 'templates/search-result.html',
				controller: 'SearchResultCtrl'
			}
		}
	})
	.state('app.favorites', {
		url: '/favorites',
		views: {
			'mainContent': {
				templateUrl: 'templates/favorites.html',
				controller: 'FavoritesCtrl'
			}
		}
	})
	.state('app.more', {
		url: '/more',
		views: {
			'mainContent': {
				templateUrl: 'templates/more.html',
				controller: 'MoreCtrl'
			}
		}
	})
	.state('app.userProfile', {
		url: '/user-profile',
		views: {
			'mainContent': {
				templateUrl: 'templates/user-profile.html',
				controller: 'UserProfileCtrl'
			}
		}
	})
	.state('app.userProperty', {
		url: '/user-property',
		views: {
			'mainContent': {
				templateUrl: 'templates/user-property.html',
				controller: 'UserPropertyCtrl'
			}
		}
	})
	.state('app.userMembership', {
		url: '/user-membership',
		views: {
			'mainContent': {
				templateUrl: 'templates/user-membership.html',
				controller: 'UserMembershipCtrl'
			}
		}
	})
	.state('app.termsOfUse', {
		url: '/terms-of-use',
		views: {
			'mainContent': {
				templateUrl: 'templates/terms-of-use.html',
			}
		}
	})
	.state('app.copyright', {
		url: '/copyright',
		views: {
			'mainContent': {
				templateUrl: 'templates/copyright.html',
			}
		}
	})
	.state('app.privacyPolicy', {
		url: '/privacy-policy',
		views: {
			'mainContent': {
				templateUrl: 'templates/privacy-policy.html',
			}
		}
	})
	;
	// if none of the above states are matched, use this as the fallback
	$urlRouterProvider.otherwise('/app/home');
});
