angular.module('starter')
.component('agentElement', {
	templateUrl: 'templates/components/agent.html',
	controller: function($scope, $state, $timeout, OpalService, SessionService){
		$scope.bindings  = this;
		$scope.agentData = [];
		$scope.pageAgent = 1;
		$scope.canLoadMoreAgentData = true;
		
		$scope.isLoadMore = function(){
			return ($scope.bindings.infiniteScroll == true && $scope.canLoadMoreAgentData);
		}

		$scope.openAgent = function($agentId) {
			angular.forEach($scope.agentData, function(agent, key) {
				if (agent.info.id === $agentId) {
					SessionService.set("agent", agent);
					$state.go('app.agent', {agentId: $agentId});
					return true;
				}
			});
		}

		$scope.getAgentData = function($page) {
			var loading = (typeof $scope.bindings.loading 		== 'undefined') ? false : $scope.bindings.loading;
			var params 	= {
				task: 	(typeof $scope.bindings.task 	== 'undefined') ? 'default' : $scope.bindings.task,
				number: (typeof $scope.bindings.number 	== 'undefined') ? 5 : $scope.bindings.number,
				id: 	(typeof $scope.bindings.id 		== 'undefined') ? 0 : $scope.bindings.id,
				paged: 	$page,
			}
			
			OpalService.sendRequest('agents', params).then(function(listAgent) {
				listAgent = listAgent['agents'];
				if(!listAgent){
					$scope.canLoadMoreAgentData = false;
					return false;
				}
				if (listAgent.length > 0) {
					angular.forEach(listAgent, function(property, key) {
						$scope.agentData.push(property);
					});
					$scope.pageAgent = $page + 1;
					$scope.$broadcast('scroll.infiniteScrollComplete');
					$scope.$broadcast('scroll.refreshComplete');
					$scope.canLoadMoreAgentData = true;
				}
				else {
					$scope.canLoadMoreAgentData = false;
				}
			});

		};
		
		$scope.loadMoreAgentData = function() {
			$scope.getAgentData($scope.pageAgent);
		};
		$scope.loadMoreAgentData();
		// console.log($scope.agentData);
	},
	bindings: {
		task: 			'=',
		id: 			'=',
		number: 		'=',
		infiniteScroll: '=',
		loading: 		'='
	}
});