angular.module('starter')
.component('propertyCommentForm', {
	templateUrl: 'templates/components/property-comment-form.html',
	controller: function($scope, $rootScope, $ionicPopup, OpalService){
		$scope.allowed 		= (typeof this.allowed == 'undefined')?true:this.allowed;
		$scope.submitted 	= false;
		$scope.commentData 	= {
			task: 'comment',
			id: (typeof this.propertyId == 'undefined')?0:this.propertyId,
		};

		if($rootScope.isLoggedIn){
			var userInfo 		= OpalService.getUserInfo();
			// console.log()
			$scope.commentData 	= {
				task: 'comment',
				id: (typeof this.propertyId == 'undefined')?0:this.propertyId,
				user_name: userInfo.info.user_login,
				user_email: userInfo.info.user_email,
				user_id: userInfo.info.ID,
				author_url: userInfo.info.user_url
			}
		}

		$scope.doComment = function(commentForm){
			$scope.submitted = true;
			if (!commentForm.$valid) {
				return false;
			}
			OpalService.sendRequest('properties', $scope.commentData).then(function(response){
				if(!response.status){
					$ionicPopup.alert({
						title: 'Message',
						template: response.err_msg
					});
				}else{
					// reset form
					$scope.submitted = false;
					$scope.commentData.content = '';
					if(!$rootScope.isLoggedIn){
						$scope.commentData.user_name = '';
						$scope.commentData.user_email = '';
						$scope.commentData.author_url = '';
					}
				}
			});
		}

	},
	bindings: {
		allowed: '=',
		propertyId: '='
	}
});