var propertyElementsCtrl = function($scope, $rootScope, $state, $ionicModal, $ionicPopup, $cordovaStatusbar, $ionicHistory, $timeout, $cordovaSocialSharing, $cordovaToast, SessionService, OpalService){
	$scope.propertyData = [];
	$scope.user 		= [];
	$scope.pageProperty = 1;
	$scope.bindings 	= this;
	$scope.canLoadMorePropertyData = true;
	if(typeof this.data == 'object'){
		$scope.propertyData = this.data;
	}else{
		$scope.getPropertyData = function($page) {
			var loading = (typeof $scope.bindings.loading 		== 'undefined') ? false : $scope.bindings.loading,
			params 		= {
				paged: 		$page,
				number: 	(typeof $scope.bindings.number 		== 'undefined') ? 5 : $scope.bindings.number,
				id: 		(typeof $scope.bindings.id 			== 'undefined') ? 0 : $scope.bindings.id,
				agent_id: 	(typeof $scope.bindings.agentId 	== 'undefined') ? 0 : $scope.bindings.agentId,
				user_id: 	(typeof $scope.bindings.userId 		== 'undefined') ? 0 : $scope.bindings.userId,
				task: 		(typeof $scope.bindings.task 		== 'undefined') ? 'default' : $scope.bindings.task,
				status: 	(typeof $scope.bindings.status 		== 'undefined') ? 'published' : $scope.bindings.status,
				tax: 		(typeof $scope.bindings.tax 		== 'undefined') ? '' : $scope.bindings.tax,
			}
			if($rootScope.isLoggedIn){
				$scope.user 	= JSON.parse(window.localStorage.getItem("userInfo"));
				params.user_id 	= $scope.user.info.ID;
			}
			
			if(params.task == 'search'){
				var search_options = SessionService.get('searchData');
				params = merge_options(params, search_options);
			}
			OpalService.sendRequest('properties', params, loading).then(function(listProperty) {
				listProperty = listProperty['properties'];
				if(!listProperty){
					$scope.canLoadMorePropertyData = false;
					return false;
				}
				if (listProperty.length > 0) {
					angular.forEach(listProperty, function(property, key) {
						$scope.propertyData.push(property);
					});
					$scope.pageProperty = $page + 1;
					$scope.$broadcast('scroll.infiniteScrollComplete');
					// $scope.$broadcast('scroll.refreshComplete');
					$scope.canLoadMorePropertyData = true;
				}
				else {
					$scope.canLoadMorePropertyData = false;
				}
			});
		};
		$scope.loadMorePropertyData = function() {
			$scope.getPropertyData($scope.pageProperty);
		};
		$scope.loadMorePropertyData();

		$scope.doRefresh = function(){
			$scope.pageProperty = 1;
			$scope.propertyData = [];
			$scope.canLoadMorePropertyData = true;
			$scope.loadMorePropertyData();
		}	
	}
	if($rootScope.isLoggedIn){
		$scope.user = SessionService.get('userInfo');
	}

	var syncData = function(id, userid){
		OpalService.sendRequest('user', 
			{
				propertyId: id,
				userId: userid,
				task: 'toggle_favorites',
			}, 
			false
		);
	};

	$scope.share = function (index) {
		var property 	= $scope.propertyData[index];
		var title 		= 'Hi, I am interested in ' + property.info.title,
		subject 		= '',
		link 			= property.info.link;
	    $cordovaSocialSharing.share( title, subject, null, link );
	}

	$scope.loginData = {
		task: 'login_favorites',
	};
	$ionicModal.fromTemplateUrl('templates/modals/login.html', {
		scope: $scope
	}).then(function(modal) {
		$scope.mLogin = modal;
	});

	$scope.openModalLogin = function(index) {
		$scope.loginData.propertyId = $scope.propertyData[index].info.id;
		$scope.keyProperty 			= index;

		$scope.mLogin.show();
		$cordovaStatusbar.style(0);
	};
	$scope.closeModalLogin = function() {
		$scope.mLogin.hide();
		$cordovaStatusbar.style(1);
	};

	$scope.doLogin = function(loginForm) {
		$scope.loginData.submitted = true;
		if (!loginForm.$valid) {
			return false;
		}
		$scope.checkErr = false;
		$scope.err_msg 	= '';
		OpalService.sendRequest('user', $scope.loginData, true).then(function(response){
			if(typeof response.err_msg == "undefined"){
				SessionService.set("is_login", true);
				SessionService.set("userInfo", response.data);

				$scope.user 			= response.data;
				$rootScope.isLoggedIn 	= true;

				$scope.propertyData[$scope.keyProperty].info.in_favorites 	= true;
				$scope.closeModalLogin();
			}else{
				$scope.checkErr = true;
				$scope.err_msg 	= response.err_msg;
			}
			$cordovaStatusbar.style(1);
		});
	};

	$scope.toggleFavorites 	= function(index, action){
		
		if(action == 'add'){
			$scope.propertyData[index].info.in_favorites 	= true;
		}else{
			$scope.propertyData[index].info.in_favorites 	= false;
		}
		// $ionicHistory.clearCache();
		syncData($scope.propertyData[index].info.id, $scope.user.info.ID);
	}

	$scope.removeFavorites = function(index){
		// $scope.propertyData[index].info.in_favorites 	= false;
		syncData($scope.propertyData[index].info.id, $scope.user.info.ID);
		$scope.propertyData.splice(index,1);
		
	}

	

	if($scope.bindings.task == 'user'){
		$scope.toogleFeatured = function(key, property){
			alert('plugin error!');
			// $scope.propertyData.splice(key, 1);
			// console.log(property.info.id);
			return false;
			OpalService.sendRequest('properties', {
				task: 'toggle_featured',
				user_id: $scope.user.info.ID,
				property_id: property.info.id,
			}, true).then(function(response){
				// $scope.propertyData.splice(key, 1);
				// console.log(response);
			});
		}

		$scope.deleteProperty = function(key, property){
			$ionicPopup.confirm({
				title: 'Delete Property',
				template: 'Are you sure you want to delete \''+property.info.title+'\'?'
		   	}).then(function(res){
		   		if(res){
		   			OpalService.sendRequest('properties', {
						task: 'delete_property',
						user_id: $scope.user.info.ID,
						property_id: property.info.id,
					}, true).then(function(response){
						if(response.status){
		   					$scope.propertyData.splice(key, 1);
		   					$ionicHistory.clearCache();
						}
						// console.log(response);
						$cordovaToast.showShortBottom(response.message, 300, 'center');

					});	
		   		}else{
		   			
		   		}
		   	});
			
		}
	}

	$scope.isFeatured 	= function(property){
		if(property.info.featured != '0'){
			return true;
		}
		return false;
	}

	$scope.isNotFound = function(){
		return $scope.propertyData.length <= 0;
	}

	$scope.isLoadMore = function(){
		return ($scope.bindings.infiniteScroll==true && $scope.canLoadMorePropertyData);
	}

	$scope.isRefresh = function(){
		return ($scope.bindings.isRefresh == true && $scope.propertyData.length > 0);
	}

	$scope.openProperty = function(property) {
		SessionService.set("property", property);
		$state.go('app.property', {propertyId: property.info.id});
		return true;
		
	};

	function merge_options(obj1,obj2){
	    var obj3 = {};
	    for (var attrname in obj1) { obj3[attrname] = obj1[attrname]; }
	    for (var attrname in obj2) { obj3[attrname] = obj2[attrname]; }
	    return obj3;
	}
		
},
propertyElementsBindings = {
	number: 		'=',
	task: 			'=',
	id: 			'=',
	agentId: 		'=',
	userId: 		'=',
	infiniteScroll: '=',
	status: 		'=',
	loading: 		'=',
	toggleDelete: 	'=',
	data: 			'=',
	isRefresh: 		'=',
	tax: 			'='
};



// Components
angular.module('starter')
.component('propertyElements', {
	templateUrl: 'templates/components/properties.html',
	controller: propertyElementsCtrl,
	bindings: propertyElementsBindings,
})
.component('propertyElementFavorites', {
	templateUrl: 'templates/components/property-favorites.html',
	controller: propertyElementsCtrl,
	bindings: propertyElementsBindings,
})
.component('propertyElementUser', {
	templateUrl: 'templates/components/property-user.html',
	controller: propertyElementsCtrl,
	bindings: propertyElementsBindings,
})
.component('propertyElementList', {
	templateUrl: 'templates/components/property-list.html',
	controller: propertyElementsCtrl,
	bindings: propertyElementsBindings,
})
;


