angular.module('starter')
.component('propertyGallery', {
	templateUrl: 'templates/components/property-gallery.html',
	controller: function($scope, $ionicModal, $ionicScrollDelegate, $ionicSlideBoxDelegate, $cordovaStatusbar, $timeout){
		$scope.thumbnail 	= this.thumbnail;
		$scope.gallery 		= this.gallery;
		$scope.countGallery = Object.keys($scope.gallery).length + 1;
		$scope.isGallery 	= $scope.countGallery > 1;
		$scope.zoomMin 		= 1;

		$ionicModal.fromTemplateUrl('templates/modals/gallery.html', {
			scope: $scope
		}).then(function(modal) {
			$scope.mGallery = modal;
		});

		$scope.showImages = function(index) {
			$scope.activeSlide = index;
			$scope.mGallery.show();
			$cordovaStatusbar.hide();
		}

		$scope.closeModal = function() {
			$scope.mGallery.hide();
			$cordovaStatusbar.show();
		};

		$scope.updateSlideStatus = function(slide) {
			var zoomFactor = $ionicScrollDelegate.$getByHandle('scrollHandle' + slide).getScrollPosition().zoom;
			if (zoomFactor == $scope.zoomMin) {
				$ionicSlideBoxDelegate.enableSlide(true);
			} else {
				$ionicSlideBoxDelegate.enableSlide(false);
			}
		};

	},
	bindings: {
		thumbnail: 	'=',
		gallery: 	'='
	}
});