angular.module('starter')
.component('propertyMap', {
	templateUrl: 'templates/components/property-map.html',
	controller: function($scope, NgMap, OpalService){
		$scope.property 			= this.data;
		$scope.placesService 		= [];
		$scope.info_position 		= $scope.property.info.map.latitude + ',' + $scope.property.info.map.longitude;
		$scope.listPlacesService 	= [
			['hospital', ['hospital'], 'img/map/hospital.png', 'fa-hospital-o'],
			['library', ['library'], 'img/map/libraries.png', 'fa-bank'],
			['pharmacy', ['pharmacy'], 'img/map/pharmacy.png', 'fa-plus-square'],
			['school', ['school'], 'img/map/school.png', 'fa-graduation-cap'],
			['shopping', ['grocery_or_supermarket','shopping_mall'], 'img/map/supermarket.png', 'fa-shopping-basket'],
			['trainstation', ['bus_station', 'subway_station', 'train_station', 'airpor'], 'img/map/transportation.png', 'fa-subway'],
		];
		$scope.cachePlacesService 	= {};
		$scope.iconPlacesService 	= '';
		$scope.streetsClass 		= '';
		$scope.placeServiceName 	= '';

		$scope.mapStyle 			= OpalService.getMapStyle();

		$scope.$on('mapInitialized', function(event, map) {
			// Setup Streets View
			$scope.panorama = $scope.map.getStreetView();
			$scope.panorama.setPosition({
				lat: Number($scope.property.info.map.latitude), 
				lng: Number($scope.property.info.map.longitude)
			});
			$scope.panorama.setPov({
				heading: 20,
				pitch: 10
			});
			$scope.panorama.setEnableCloseButton(false);
			// $scope.panorama.setLinksControl(false);

			//Setup Services
			$scope.mapServices = new window.google.maps.places.PlacesService( $scope.map );
			var _location = {
	        	lat: Number($scope.property.info.map.latitude), 
				lng: Number($scope.property.info.map.longitude)
	        };
	        angular.forEach($scope.listPlacesService, function(_v){
	        	$scope.mapServices.nearbySearch({
		            location: _location,
		            radius: 2000,
		            bounds: $scope.map.getBounds(),
		            type: _v[1],
		        },function(results, status){
		        	if (status === google.maps.places.PlacesServiceStatus.OK) {
		        		$scope.cachePlacesService[_v[0]] = results;
		        	}
		        });
	        });

		});

		$scope.openServiceInfo = function(e, place, key){
			var info = $scope.map.infoWindows['service-info'];
			$scope.placeServiceName = place.name;
			info.__open($scope.map,$scope, $scope.map.markers['place-service-'+key]);
		}
		
		$scope.nearByAction = function($type, $action, $icon){
			$scope.streetsClass = '';
			$scope.placesService = [];
			$scope.panorama.setVisible(false);
			$scope.iconPlacesService = $icon;
			if(typeof $scope.cachePlacesService[$type] != 'undefined'){
				$scope.placesService = $scope.cachePlacesService[$type];
			}else{
				$scope.mapServices.nearbySearch({
		            location: {
		            	lat: Number($scope.property.info.map.latitude), 
						lng: Number($scope.property.info.map.longitude)
		            },
		            radius: 2000,
		            bounds: $scope.map.getBounds(),
		            type: $action
		        },function(results, status){
		        	if (status === google.maps.places.PlacesServiceStatus.OK) {
		        		$scope.cachePlacesService[$type] = results;
		        		$scope.placesService = results;
		        	}
		        });
			}
		}
		$scope.openStreetView = function() {
			var toggle = $scope.panorama.getVisible();
			if (toggle == false) {
				$scope.panorama.setVisible(true);
				$scope.streetsClass = 'active';
			} else {
				$scope.streetsClass = '';
				$scope.placesService = [];
				$scope.panorama.setVisible(false);
			}
		}

		$scope.$on("$ionicParentView.afterLeave", function(event, data){
			$scope.panorama.setVisible(false);
		});
	},
	bindings: {
		data: '='
	}
});