angular.module('starter')
.component('searchMapResult', {
	templateUrl: 'templates/components/search-map-result.html',
	controller: function($scope, $state, SessionService, OpalService){
		$scope.searchProperties = this.data;
		$scope.isEmpty 	= false;
		$scope.isMap 	= false;
		$scope.mapStyle = OpalService.getMapStyle();

		if(	$scope.searchProperties == 'undefined'){
			$scope.isEmpty = true;
		}else{
			$scope.isMap 		= true;
		    $scope.dynMarkers 	= [];
		    $scope.bounds 		= new google.maps.LatLngBounds();
		    // console.log($scope.bounds);

		   	var optionClusterer = {
		   		ignoreHidden: true,
		        maxZoom: 10,
		        styles: [{
		            textColor: '#000000',
		            url: 'img/map/cluster-icon.png',
		            height: 55,
		            width: 30,
		            anchor: [5,0]
		        }]
		   	};

		   	$scope.$on('mapInitialized', function(event, map) {
		   		$scope.map 	= map;
		   		var bounds 	= new google.maps.LatLngBounds();
		   		if(Object.keys($scope.map.markers).length == 1){
		   			$scope.map.setCenter($scope.map.markers[0].getPosition());
		   		}else{
		   			for (var k in $scope.map.markers) {
						var cm 	= $scope.map.markers[k];
						$scope.dynMarkers.push(cm);
						bounds.extend(cm.getPosition());
					};
					$scope.markerClusterer = new MarkerClusterer($scope.map, $scope.dynMarkers, optionClusterer);
			      	$scope.map.setCenter(bounds.getCenter());
			      	$scope.map.fitBounds(bounds);  
		   		}
	            
		   	});

		   	


		}

		$scope.$on('$destroy', function(){
			$scope.map.markers = null;
			// $scope.dynMarkers = [];
			$scope.markerClusterer.clearMarkers();
			console.log('destroy');
		});

		$scope.openPropertyDetail = function(e, property){
			SessionService.set("property", property);
			$state.go('app.property', {propertyId: property.info.id});
			return true;
		}
	},
	bindings: {
		data: '='
	}
});