opal_controller
.controller('AgentsCtrl', function($scope, $state, $timeout, OpalService, SessionService) {
	$scope.bindings  = this;
	$scope.agentData = [];
	$scope.pageAgent = 1;
	$scope.canLoadMoreAgentData = true;

	$scope.isLoadMore = function(){
		return ($scope.bindings.infiniteScroll == true && $scope.canLoadMoreAgentData);
	}

	$scope.openAgent = function($agentId) {
		angular.forEach($scope.agentData, function(agent, key) {
			if (agent.info.id === $agentId) {
				SessionService.set("agent", agent);
				$state.go('app.agent', {agentId: $agentId});
				return true;
			}
		});
	}

	$scope.getAgentData = function($page) {
		var loading = (typeof $scope.bindings.loading == 'undefined') ? false : $scope.bindings.loading;
		var params 	= {
			task: 	'default',
			number: 10,
			paged: 	$page,
		}

		OpalService.sendRequest('agents', params).then(function(listAgent) {
			listAgent = listAgent['agents'];
			if(!listAgent){
				$scope.canLoadMoreAgentData = false;
				return false;
			}
			if (listAgent.length > 0) {
				angular.forEach(listAgent, function(agent, key) {
					$scope.agentData.push(agent);
				});
				$scope.pageAgent = $page + 1;
				$scope.$broadcast('scroll.infiniteScrollComplete');
				$scope.$broadcast('scroll.refreshComplete');
				$scope.canLoadMoreAgentData = true;
			}
			else {
				$scope.canLoadMoreAgentData = false;
			}
		});

	};

	$scope.loadMoreAgentData = function() {
		$scope.getAgentData($scope.pageAgent);
	};
	$scope.loadMoreAgentData();
		// console.log($scope.agentData);
	});