opal_controller
.controller('MainCtrl', function($scope, $rootScope, $state, $ionicModal, $ionicHistory, $ionicLoading, $timeout, $cordovaStatusbar, SessionService, OpalService) {
	$scope.settings = {
		searchResultActive: 1,
	}

	$scope.openPage = function($page){
		$ionicHistory.nextViewOptions({
			historyRoot: true,
			disableAnimate: true,
		});
		$state.go($page);
		return true;
	}

	////////////////////////////////////////////////////////////////////////////////
	//////////////////////////////     Login        ////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	$rootScope.isLoggedIn 	= false;
	$scope.loginData 		= {
		task: 'login',
		submitted: false
	};

	$scope.checkErr = false;
	$scope.err_msg 	= '';

	if(OpalService.checkLoggedIn()){
		$rootScope.isLoggedIn	= true;
		$scope.user 			= SessionService.get("userInfo");
	}

	$scope.openModalLogin = function() {
		$ionicModal.fromTemplateUrl('templates/modals/login.html', {
			scope: $scope
		}).then(function(modal) {
			$scope.mLogin = modal;
			$scope.mLogin.show();
		});
		$cordovaStatusbar.style(0);
	};
	$scope.closeModalLogin = function() {
		$scope.mLogin.remove();
		$cordovaStatusbar.style(1);
	};

	$scope.doLogout = function(){
		$ionicLoading.show({
			template: '<ion-spinner></ion-spinner>'
		});
		SessionService.destroy("is_login");
		SessionService.destroy("userInfo");
		$scope.loginData.submitted 	= false;
		$scope.loginData.user_login = '';
		$scope.loginData.user_pass 	= '';
		$rootScope.isLoggedIn 		= false;

		$ionicHistory.nextViewOptions({
			historyRoot: false,
			disableAnimate: true,
		});

		$state.go('app.more');

		$timeout(function(){
	        $ionicLoading.hide();
  		},500);
	}

	$scope.doLogin = function() {
		$scope.checkErr = false;
		$scope.err_msg 	= '';
		OpalService.sendRequest('user', $scope.loginData, true).then(function(response){
			if(typeof response.err_msg == "undefined"){
				SessionService.set("is_login", true);
				SessionService.set("userInfo", response);
				$rootScope.isLoggedIn 	= true;
				$scope.user 			= response;
				$scope.closeModalLogin();
			}else{
				$scope.checkErr = true;
				$scope.err_msg 	= response.err_msg;
			}
		});
	};
	////////////////////////////////////////////////////////////////////////////////
	///////////////////////////    End Login     ///////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////////
	////////////////////////////     Register        ///////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	$scope.checkErrRegister = false;
	$scope.registerData 	= {
		task: 'register',
		submitted: false
	}

	$ionicModal.fromTemplateUrl('templates/modals/register.html', {
		scope: $scope
	}).then(function(modal) {
		$scope.mRegister = modal;
	});

	$scope.openModalRegister = function() {
		$scope.mLogin.hide();
		$scope.mRegister.show();
		$cordovaStatusbar.style(0);
	};
	$scope.closeModalRegister = function() {
		$scope.mRegister.hide();
		$cordovaStatusbar.style(1);
	};

	$scope.doRegister = function(registerForm) {
		$scope.err_msg = '';
		OpalService.sendRequest('user', $scope.registerData, true).then(function(response){
			if(response.success){
				$rootScope.isLoggedIn 	= true;
				$scope.user 			= response.user;

				SessionService.set('userProfile', $scope.user);
				SessionService.set('is_login', true);
				$scope.mRegister.remove();

				$state.go('app.userProfile');
			}else{
				$scope.checkErrRegister = true;
				$scope.err_register_msg = response.message;
			}
		});
	};

	////////////////////////////////////////////////////////////////////////////////
	//////////////////////////     End Register        /////////////////////////////
	////////////////////////////////////////////////////////////////////////////////
	$scope.appSettings = SessionService.get('appSettings');
	OpalService.sendRequest('settings', {
		task: 'all'
	}).then(function(response){
		$scope.appSettings = response.settings;
		SessionService.set('appSettings', response.settings);
	});

	$scope.doRefresh = function(){
        location.reload();
	}
	
});


