opal_controller
.controller('MoreCtrl', function($scope, $rootScope, $ionicLoading, $ionicModal, $timeout, $cordovaStatusbar, $ionicActionSheet, $cordovaFileTransfer, $cordovaCamera, SessionService, OpalService) {

	if(!$scope.appSettings){
		// Setup Setting
		OpalService.sendRequest('settings', {
			task: 'all'
		}).then(function(response){
			SessionService.set('appSettings', response.settings);
			$scope.appSettings 	= response.settings;
		});
	}

	$scope.showChangeAvatar = function() {
		// Show the action sheet
		$scope.hideSheet = $ionicActionSheet.show({
			buttons: [
				{ text: 'Take a New Profile Picture' },
				{ text: 'Select Photo on Phone' },
			],
			cancelText: 'Cancel',
			titleText: 'Update Profile Picture',
			cancel: function() {
				// add cancel code..
			},
			buttonClicked: function(index) {
				if(index == 0){
					$scope.takePhoto();
				}else if(index == 1){
					$scope.choosePhoto();
				}
			}
		});
	};
	
	$scope.uploadAvatar = function(imageData){
		var server 		= OpalService.imageUpload + '&user_id=' + $scope.user.info.ID,
		date 			= new Date(),
		filePath 		= imageData,
    	options 		= {
            fileKey: "file",
            fileName: imageData.substr(imageData.lastIndexOf('/') + 1),
            chunkedMode: false,
            mimeType: "image/jpg"
        };
        
        $scope.hideSheet();
        $ionicLoading.show({
			template: '<ion-spinner></ion-spinner>'
		});

        $cordovaFileTransfer.upload(server, filePath, options).then(function(result) {
        	var response = JSON.parse(result.response);
        	if(response.success){
        		$scope.user.info.avatar = response.url;
        		SessionService.set('userInfo', $scope.user);
        		alert('success');
        	}else{
        		alert('ERROR Response');
        	}
            $ionicLoading.hide();
        }, function(err) {
        	alert('ERROR: ' + JSON.stringify(err) );
        	$ionicLoading.hide();
            console.log("ERROR: " + JSON.stringify(err));
        }, function (progress) {

        });
	}

	$scope.takePhoto = function () {
		var options = {
			quality: 			75,
			destinationType: 	Camera.DestinationType.FILE_URI,
			sourceType: 		Camera.PictureSourceType.CAMERA,
			allowEdit: 			true,
			encodingType: 		Camera.EncodingType.JPEG,
			targetWidth: 		300,
			targetHeight: 		300,
			popoverOptions: 	CameraPopoverOptions,
			saveToPhotoAlbum: 	false
		};

		$cordovaCamera.getPicture(options).then(function (imageData) {
			$scope.uploadAvatar(imageData);
		}, function (err) {
            $scope.hideSheet();
        });
	}

	$scope.choosePhoto = function () {
		var options = {
			quality: 75,
			destinationType: 	Camera.DestinationType.FILE_URI,
			sourceType: 		Camera.PictureSourceType.PHOTOLIBRARY,
			allowEdit: 			true,
			encodingType: 		Camera.EncodingType.JPEG,
			targetWidth: 		300,
			targetHeight: 		300,
			popoverOptions: 	CameraPopoverOptions,
			saveToPhotoAlbum: 	false
		};

		$cordovaCamera.getPicture(options).then(function (imageData) {
			$scope.uploadAvatar(imageData);
		}, function (err) {
            $scope.hideSheet();
        });
	}

});