opal_controller
.controller('SearchCurrentLocationCtrl', function($scope, $state, $ionicLoading, $ionicPopover, $cordovaGeolocation, $cordovaToast, $timeout, NgMap, SessionService, OpalService) {
	var posOptions 			= {
		timeout: 10000, 
		enableHighAccuracy: false
	};
	$scope.propertyData 	= [];
	$scope.currentPosition 	= '';
	$scope.mapStyle 		= OpalService.getMapStyle();
	$scope.currentLatitude 	= '';
	$scope.currentLongitude = '';
	$scope.cache 			= false;
	$scope.loading 			= true;
	$scope.distance 		= 10;

	$scope.checkLoading = function(){
		return $scope.loading;
	}

	$cordovaGeolocation
	.getCurrentPosition(posOptions)
	.then(function (position) {
		$scope.currentLatitude 		= position.coords.latitude;
		$scope.currentLongitude 	= position.coords.longitude;
		NgMap.getMap().then(function (map) {
			$scope.map = map;
			$scope.setupData();
		});

	}, function(err) {
		console.log('Err');
		console.log(err);
	});

	$scope.setupData = function(){
		$scope.loading 	= true;
		OpalService.sendRequest('properties',
		{
			task: 'search_near_location',
			latitude: $scope.currentLatitude,
			longitude: $scope.currentLongitude,
			distance: $scope.distance,
		},false
		).then(function(response){
			if(response.status == 1){
				$scope.propertyData = response.data.properties;
				$timeout(function() {
					var bounds = new google.maps.LatLngBounds();
					bounds.extend(new google.maps.LatLng($scope.currentLatitude, $scope.currentLongitude));
					for (var i=0; i < $scope.propertyData.length; i++) {
						var latlng = new google.maps.LatLng($scope.propertyData[i].info.map.latitude, $scope.propertyData[i].info.map.longitude);
						bounds.extend(latlng);
					}
					// console.log(bounds.getCenter());
					$scope.map.setCenter(bounds.getCenter());
					$scope.map.fitBounds(bounds);

					// if($scope.propertyData.length > 0){
					// 	$cordovaToast.showShortBottom('success!', 300, 'center');
					// }
				}, 1000);
			}

			// $ionicLoading.hide();
			// console.log(response);

			
			$scope.loading = false;

		});
	}

	$scope.openPropertyDetail = function(e, property){
		SessionService.set("property", property);
		$state.go('app.property', {propertyId: property.info.id});
		return true;
	}

	// Popover
	$ionicPopover.fromTemplateUrl('templates/popover/more-search-location.html', {
		scope: $scope
	}).then(function(popover) {
		$scope.popover = popover;
	});

	$scope.openPopover = function($event) {
		$scope.popover.show($event);
	};

	$scope.actionDistance = function(distance){
		$scope.popover.hide();
		$scope.distance = distance;
		$scope.setupData();
	}


	//Cleanup the popover when we're done with it!
	$scope.$on('$destroy', function() {
		$scope.popover.remove();
	});

});