opal_controller
.controller('SearchCtrl', function($scope, $state, $ionicHistory, SessionService, OpalService){
	$scope.dataOption = [];
	$scope.dataSearch = {
		task: 'search',
		status: -1,
		search_text: ''
	};

	$scope.isLoadded  = false;
	if(!$scope.appSettings){
		$scope.fields 		= $scope.appSettings.search;
		$scope.isLoadded 	= true;
		$scope.dataSearch.min_price = $scope.fields.price.ranger_min;
		$scope.dataSearch.max_price = $scope.fields.price.ranger_max;
	}else{
		// Setup Setting
		OpalService.sendRequest('settings', {
			task: 'all'
		}).then(function(response){
			$scope.appSettings 	= response.settings;
			$scope.fields 		= response.settings.search;
			$scope.isLoadded 	= true;
			$scope.dataSearch.min_price = $scope.fields.price.ranger_min;
			$scope.dataSearch.max_price = $scope.fields.price.ranger_max;
			SessionService.set('appSettings', response.settings);
		});
	}

	$scope.$on('$ionicView.loaded', function(){
		$ionicHistory.currentView();
	});
	
	$scope.setStatusBar = function(value){
		$scope.dataSearch.status = value;
	}

	$scope.clearSearch 	= function(){
		$scope.dataSearch.search_text = '';
	}

	$scope.getOptions 	= function(options, key){
		$scope.dataOption[key] = [{name:'All', value: '-1'}];
		angular.forEach(options, function(v){
			$scope.dataOption[key].push({name: v.name, value: v.slug});
		});
		$scope.dataSearch[key] = "-1";
	}

	$scope.checkTypeInput = function(key){
		if( key == 'info' || key == 'price' || key == 'status'){
			return false;
		}
		return true;
	}

	$scope.searchAction = function(){
		$scope.dataSearch['number'] = 100;
		$scope.dataSearch['task'] 	= 'search';
		
		OpalService.sendRequest('properties', $scope.dataSearch, true).then(function(response){
 			if(typeof response.properties == 'undefined'){
 				SessionService.set('searchProperties', []);
 			}else{
 				SessionService.set('searchProperties', response.properties);
 			}
 			$state.go('app.searchResult');
		});
	}
});