opal_controller
.controller('UserProfileCtrl', function($scope, $ionicModal, $cordovaStatusbar, $ionicActionSheet, $cordovaFileTransfer, $cordovaCamera, SessionService, OpalService){
	// Profile Info
	// $scope.user 	= JSON.parse(window.localStorage.getItem("userInfo"));
	$scope.isSave 	= false;
	$scope.$watch('user', function($new, $old){
		if($old !== $new){
			$scope.isSave = true;
		}
	}, true);

	$scope.updateProfile = function(){
		$scope.isSave 	= false;
		OpalService.sendRequest('user', {
			task: 'update_meta',
			datajson: JSON.stringify($scope.user.info),
		}, true).then(function(response){
			if(response.success){
				SessionService.set('userInfo', $scope.user);
			}
		});
	}
	// End Profile Info

	// Change Password
	$scope.isSaveChangePass = false;
	$scope.changePassword 	= {
		userId: $scope.user.info.ID,
		oldPass: '',
		newPass: '',
		reNewPass: '',
	};
	// console.log($scope.user);
	$scope.$watch('changePassword', function($new, $old){
		if($old !== $new && $new.newPass == $new.reNewPass && $new.newPass != ''){
			$scope.isSaveChangePass = true;
		}
	}, true);
	$ionicModal.fromTemplateUrl('templates/modals/change-password.html', {
		scope: $scope
	}).then(function(modal) {
		$scope.mChangePass = modal;
	});
	$scope.openModalChangePassword = function() {
		$scope.mChangePass.show();
		$cordovaStatusbar.style(0);
	};
	$scope.closeModalChangePassword = function() {
		$scope.mChangePass.hide();
		$cordovaStatusbar.style(1);
	};

	$scope.updatePassword = function(){
		OpalService.sendRequest('user', {
			task: 'update_password',
			datajson: JSON.stringify($scope.changePassword),
		}).then(function(response){
			$scope.changePassword 	= {
				userId: $scope.user.info.ID,
				oldPass: '',
				newPass: '',
				reNewPass: '',
			};
			$scope.isSaveChangePass 	= false;
		});
	}

	// End Change Password



	
	$scope.showChangeAvatar = function() {
		// Show the action sheet
		$scope.hideSheet = $ionicActionSheet.show({
			buttons: [
				{ text: 'Take a New Profile Picture' },
				{ text: 'Select Photo on Phone' },
			],
			cancelText: 'Cancel',
			titleText: 'Update Profile Picture',
			cancel: function() {
				// add cancel code..
			},
			buttonClicked: function(index) {
				if(index == 0){
					$scope.takePhoto();
				}else if(index == 1){
					$scope.choosePhoto();
				}
			}
		});
	};
	$scope.uploadAvatar = function(imageData){
		var server 		= OpalService.imageUpload + '&user_id=' + $scope.user.info.ID,
		date 			= new Date(),
		filePath 		= imageData,
    	options 		= {
            fileKey: "file",
            fileName: imageData.substr(imageData.lastIndexOf('/') + 1),
            chunkedMode: false,
            mimeType: "image/jpg"
        };
        
        $scope.hideSheet();
        $ionicLoading.show({
			template: '<ion-spinner></ion-spinner>'
		});

        $cordovaFileTransfer.upload(server, filePath, options).then(function(result) {
        	var response = JSON.parse(result.response);
        	if(response.success){
        		$scope.user.info.avatar = response.url;
        		SessionService.set('userInfo', $scope.user);
        		alert('success');
        	}else{
        		alert('ERROR Response');
        	}
            $ionicLoading.hide();
        }, function(err) {
        	alert('ERROR: ' + JSON.stringify(err) );
        	$ionicLoading.hide();
            console.log("ERROR: " + JSON.stringify(err));
        }, function (progress) {

        });

	}

	$scope.takePhoto = function () {
		var options = {
			quality: 			75,
			destinationType: 	Camera.DestinationType.FILE_URI,
			sourceType: 		Camera.PictureSourceType.CAMERA,
			allowEdit: 			true,
			encodingType: 		Camera.EncodingType.JPEG,
			targetWidth: 		300,
			targetHeight: 		300,
			popoverOptions: 	CameraPopoverOptions,
			saveToPhotoAlbum: 	false
		};

		$cordovaCamera.getPicture(options).then(function (imageData) {
			$scope.uploadAvatar(imageData);
		}, function (err) {
            $scope.hideSheet();
        });
	}

	$scope.choosePhoto = function () {
		var options = {
			quality: 75,
			destinationType: 	Camera.DestinationType.FILE_URI,
			sourceType: 		Camera.PictureSourceType.PHOTOLIBRARY,
			allowEdit: 			true,
			encodingType: 		Camera.EncodingType.JPEG,
			targetWidth: 		300,
			targetHeight: 		300,
			popoverOptions: 	CameraPopoverOptions,
			saveToPhotoAlbum: 	false
		};

		$cordovaCamera.getPicture(options).then(function (imageData) {
			$scope.uploadAvatar(imageData);
		}, function (err) {
            $scope.hideSheet();
        });
	}
});
