angular.module('starter')
.directive('actualSrc', function () {
	return {
		link: function postLink(scope, element, attrs) {
			attrs.$observe('actualSrc', function(newVal){
				if(newVal !== undefined){
					var img = new Image();
					img.src = attrs.actualSrc;
					angular.element(img).bind('load', function () {
						element.attr("src", attrs.actualSrc);
					});
				}
			});

		}
	};
})
.directive('date', function ($filter) {
	return {
		link: function postLink(scope, element, attrs) {
			element.text($filter('date')(attrs.date, "MMM d, yyyy"));
		}
	};
})

.directive('hideSearchIcon', function($rootScope, $ionicHistory) {
    var stateViews = [];
    return {
        link: function(scope, $el) {
            $rootScope.hideSearch = 'hide';
            if(stateViews.indexOf($ionicHistory.currentStateName()) < 0) {
                stateViews.push($ionicHistory.currentStateName());
            }
            scope.$on('$destroy', function() {
                if(stateViews.indexOf($ionicHistory.currentStateName()) < 0){
                    $rootScope.hideSearch = '';
                }
            });
        }
    };
})

.directive('hideTabs', function($rootScope, $ionicHistory) {
    var stateViews = [];
    return {
        link: function(scope, $el) {
            $rootScope.hideTabs = 'tabs-item-hide';
            if(stateViews.indexOf($ionicHistory.currentStateName()) < 0) {
                stateViews.push($ionicHistory.currentStateName());
            }
            scope.$on('$destroy', function() {
                if(stateViews.indexOf($ionicHistory.currentStateName()) < 0){
                    $rootScope.hideTabs = '';
                }
            });
        }
    };
})
.directive('ngMin', function() {
  return {
    restrict : 'A',
    require : ['ngModel'],
    compile: function($element, $attr) {
      return function linkDateTimeSelect(scope, element, attrs, controllers) {
        var ngModelController = controllers[0];
        scope.$watch($attr.ngMin, function watchNgMin(value) {
          element.attr('min', value);
          ngModelController.$render();
        })
      }
    }
  }
})
.directive('ngMax', function() {
  return {
    restrict : 'A',
    require : ['ngModel'],
    compile: function($element, $attr) {
      return function linkDateTimeSelect(scope, element, attrs, controllers) {
        var ngModelController = controllers[0];
        scope.$watch($attr.ngMax, function watchNgMax(value) {
          element.attr('max', value);
          ngModelController.$render();
        })
      }
    }
  }
})

;