<?php

abstract class Opalestate_Abstract{
	
	protected $is_membership = false;

	public function __construct(){
		$this->is_membership = class_exists('OpalMembership');
	}

	public function action(){
		//http://stackoverflow.com/questions/18382740/cors-not-working-php
		if (isset($_SERVER['HTTP_ORIGIN'])) {
			header("Access-Control-Allow-Origin: {$_SERVER['HTTP_ORIGIN']}");
			header('Access-Control-Allow-Credentials: true');
			header('Access-Control-Max-Age: 86400'); // cache for 1 day
		}

		// Access-Control headers are received during OPTIONS requests
		if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {
			if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
				header("Access-Control-Allow-Methods: GET, POST, OPTIONS");
			if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
				header("Access-Control-Allow-Headers:        {$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");
			exit(0);
		}

		$method = 'action_' . $this->get_param('task');
		if( method_exists($this, $method) ){
			return $this->$method();
		}else{
			return array();
		}
	}

	/**
	 * Number of results to display per page
	 *
	 * @access public
	 * @since  1.1
	 * @global $wp_query
	 * @return int $per_page Results to display per page (default: 10)
	 */
	protected function per_page() {
		global $wp_query;
		$per_page = isset( $wp_query->query_vars['number'] ) ? $wp_query->query_vars['number'] : 10;
		return apply_filters( 'opalestate_api_results_per_page', $per_page );
	}

	protected function get_param($paramName, $default = null){
    	$post 		= json_decode(file_get_contents('php://input'), true);
    	$post 		= is_array($post) ? $post : array();
    	$_REQUEST 	= array_merge($_REQUEST, $post);
        if (isset($_REQUEST[$paramName]) && $_REQUEST[$paramName]) {
            return $_REQUEST[$paramName];
        }
        return $default;
    }

    protected function get_params(){
    	$post 		= json_decode(file_get_contents('php://input'), true);
    	$post 		= is_array($post) ? $post : array();
    	$_REQUEST 	= array_merge($_REQUEST, $post);
        return $_REQUEST;
    }

    protected function _getQueryData($args, $type){
		$properties = array();
		$property_list = get_posts( $args );
		if ( $property_list ) {
			$i = 0;
			foreach ( $property_list as $property_info ) {
				$properties[$type][$i] = $this->_formatData( $property_info );
				$i ++;
			}
			return $properties;
		}
		return array();
	}

}