<?php 

class Opalestate_Action_Settings extends Opalestate_Abstract{

	public function action_all(){
		return 
		array(
			'settings' => array(
				'membership' => $this->is_membership,
				'more' => array(
					'enable_term_of_use' 	=> opalestate_get_option( 'mobile_enable_term_of_use' ),
					'term_of_use' 			=> wpautop(opalestate_get_option( 'mobile_term_of_use' )),
					'enable_privacy_policy' => opalestate_get_option( 'mobile_enable_privacy_policy' ),
					'privacy_policy' 		=> wpautop(opalestate_get_option( 'mobile_privacy_policy' )),
					'enable_copyright' 		=> opalestate_get_option( 'mobile_enable_copyright' ),
					'copyright' 			=> wpautop(opalestate_get_option( 'mobile_copyright' )),
				),
				'search' => array(
					'location' 	=> get_terms('opalestate_location', array('hide_empty'=> false)),
					'types' 	=> get_terms('opalestate_types', 	array('hide_empty'=> false)),
					'status' 	=> get_terms('opalestate_status', 	array('hide_empty'=> false)),
					'info' 		=> OpalEstate_Search::get_setting_search_fields(),
					'price' 	=> array(
						'ranger_min' => opalestate_options( 'search_min_price', 0 ),
						'ranger_max' => opalestate_options( 'search_max_price', 10000000 ),
					)
				),
				'default' => array(
					'google_api' => opalestate_options( 'google_map_api_keys' ),
				),
			)
		);
	}
	
	public function action_search_fields(){
		$fields = array();
		$fields['data']['location'] = get_terms('opalestate_location', 	array('hide_empty'=> false));
		$fields['data']['types'] 	= get_terms('opalestate_types', 	array('hide_empty'=> false));
		$fields['data']['status'] 	= get_terms('opalestate_status', 	array('hide_empty'=> false));
		$fields['data']['info'] 	= OpalEstate_Search::get_setting_search_fields();
		$fields['data']['price'] 	= array(
			'ranger_min' => opalestate_options( 'search_min_price', 0 ),
			'ranger_max' => opalestate_options( 'search_max_price', 10000000 ),
		);
		return $fields;
	}

	public function action_search_field_status(){
		return array('status' => get_terms('opalestate_status', 	array('hide_empty'=> false)) );
	}
	

	public function action_search_field_location(){
		return array('location' => get_terms('opalestate_location', array('hide_empty'=> false)) );
	}

	public function action_search_field_type(){
		return array('type' => get_terms('opalestate_types', 	array('hide_empty'=> false)) );
	}


	public function action_search_info(){
		$fields = array();
		$fields['data'] = OpalEstate_Search::get_setting_search_fields();
		return $fields;
	}

	
}