<?php

final class OpalEstateMobile_Admin_Template{

	public function __construct(){
		add_filter( 'opalestate_settings_tabs',  array(__CLASS__,'setting_mobileapp_tab')  );
		add_filter( 'opalestate_registered_mobileapp_page_settings',  array(__CLASS__,'setting_mobileapp_fields')  );
	}

	public static function setting_mobileapp_tab( $tabs ){
		$tabs['mobileapp_page'] =	__( 'Mobile App', 'opalestate-api' );
		return $tabs;
	}

	public static function setting_mobileapp_fields( $fields=array() ){
		$fields = array(
			'id' 		=> 'mobileapp_page',
			'title' 	=> __( 'Mobile App Settings', 'opalestate-api' ),
			'show_on' 	=> array( 
				'key' 		=> 'options-page', 
				'value' 	=> array( 'opalestate_settings' ), 
				),
			'fields'   	=> apply_filters( 'opalestate_settings_mobileapp', 
				array(
					array(
						'name' 		=> __( 'Mobile App Page Settings', 'opalestate-api' ),
						'desc' 		=> '<hr>',
						'id'   		=> 'opalestate_title_mobile_settings',
						'type' 		=> 'title'
					),
					array(
						'name'    => __( 'Enable \'Terms of Use\' menu', 'opalestate-api' ),
						'desc'    => __( 'Enable or Disable \'Terms of Use\' menu.', 'opalestate-api' ),
						'id'      => 'mobile_enable_term_of_use',
						'type'    => 'checkbox'
					),
					array(
						'id'      	=> 'mobile_term_of_use',
						'name'    	=> __( 'Content Term of Use', 'opalestate-api' ),
						'type'    	=> 'wysiwyg',
						'rows'		=> 5,
						'options' 	=> array(
								'textarea_rows' => 10,
							)
					),
					array(
						'name'    => __( 'Enable \'Privacy Policy\' menu', 'opalestate-api' ),
						'desc'    => __( 'Enable or Disable \'Privacy Policy\' menu.', 'opalestate-api' ),
						'id'      => 'mobile_enable_privacy_policy',
						'type'    => 'checkbox'
					),
					array(
						'id'      	=> 'mobile_privacy_policy',
						'name'    	=> __( 'Content Privacy Policy', 'opalestate-api' ),
						'type'    	=> 'wysiwyg',
						'rows'		=> 5,
						'options' 	=> array(
								'textarea_rows' => 10,
							)
					),
					array(
						'name'    => __( 'Enable \'Copyright\' menu', 'opalestate-api' ),
						'desc'    => __( 'Enable or Disable \'Copyright\' menu.', 'opalestate-api' ),
						'id'      => 'mobile_enable_copyright',
						'type'    => 'checkbox'
					),
					array(
						'id'      	=> 'mobile_copyright',
						'name'    	=> __( 'Content Copyright', 'opalestate-api' ),
						'type'    	=> 'wysiwyg',
						'rows'		=> 5,
						'options' 	=> array(
								'textarea_rows' => 10,
							)
					),
				)
			),
		);
		return $fields;
	}

}

if(is_admin()){
	new OpalEstateMobile_Admin_Template();
}